// Raspberry Pico servo
// Details on:
// https://homofaciens.de/technics-physical-computing-PICO-servo_en.htm

$fn = 100;

M4_hole = 4.2;
M4_head = 8;
M4_nut_e = 7.66+1.0;
M5_nut_e = 8.79+1.0;
M6_nut_e = 11.05+1.5;
M8_nut_e = 14.38+1.0;
M3_hole = 3.3;
M3_nut_e = 6.3;

bb8_do = 22.2;
bb8_h = 7;


// Servo dimensions
s_l = 205;
s_w = 100;
s_wall = 2;
motor_shift_x = 55;
motor_m_dis = 31.5;
mount_e = 10;
ap_m_r = 38; 

shaft_m = 6;
shaft_1 = 6;
shaft_2 = 6;
shaft_3 = 9;

shaft_x1 = 47;
shaft_x2 = 104;

//translate([0, 100, 0]){
//    cylinder(d=10, h=5, $fn=3);
//    cylinder(d=10, h=1, $fn=300);
//} 


assembled = 1;
cut = 1;

  translate([-50, 0, -15]){
    cylinder(d=5, h=175, center=true);
  }
  translate([104, 0, 50]){
    cylinder(d=8, h=100, center=true);
  }

if(assembled==1){
  // Gear shafts
  translate([0, 0, 45.5]){
    cylinder(d=6, h=42, center=true);
  }
  translate([46, 0, 34.5]){
    cylinder(d=6, h=64, center=true);
  }

  difference(){
    union(){
      translate([112.5, 10-s_w/2, -43])rotate([90, 0, 0])
      pico_mount();
      
      translate([112.25, 20-s_w/2, -13.5])rotate([90, 0, 0])
      pico_mount_mount();

      translate([112.25, 40-s_w/2, -43.5])rotate([90, 0, 0])
      plug_mount();

      translate([0, 0, -50])cylinder(d=55, h=70, center=true);

      translate([motor_shift_x, 0, 0])
      base_plate();

      translate([motor_shift_x, 0, -100])
      bottom_case();

      translate([motor_shift_x, 0, 2])
      top_case();

      translate([motor_shift_x, 0, 69])rotate([180, 0, 0])
      base_plate(m_h1=7,m_h2=12,type=1);

      translate([0, 0, 6])
      pinion();
      translate([0, 0, 15])rotate([180, 0, 270])
          sensor_wheel_magnets(sw_d=60, sw_h=1.5, sw_teeth=3, sw_shaft=6);

      translate([0, 0, s_wall])
          anchor_point();

      translate([105, 0, 83])rotate([180, 0, 90])
          lever();


      translate([shaft_x1, 0, 16])rotate([0, 0, 2]){
        transmission(g1=78,
                     g2=12,
                     h1=5,
                     h2=17.5,
                     shaft=shaft_1,
                     mod1=3,
                     mod2=3.45,
                     ring_h=8.5,
                     ring_d1=50,
                     ring_d2=30);
      }

      translate([0, 0, 31.8])rotate([0, 0,- 1.0]){
        transmission(g1=69,
                     g2=32,
                     h1=6,
                     h2=25,
                     shaft=shaft_2,
                     mod1=3.45,
                     mod2=3.85,
                     ring_h=15,
                     ring_d1=60,
                     ring_d2=46);
      }

      translate([shaft_x1, 0, 61.8])rotate([180, 0, 5]){
        transmission(g1=40, 
                     g2=16,
                     h1=7,
                     h2=16,
                     shaft=shaft_1,
                     mod1=3.85,
                     mod2=5.05);
      }
      translate([0, 0, 6])outputGear();  
    }
    if(cut == 1){
      translate([0, 100, 0]){
        cube(size=[500, 200, 300], center=true);
      }
    }
  }
  
}
else{
//  base_plate(); // Base plate
//  base_plate(m_h1=7,m_h2=12,type=1); // Top plate
//  h_bridge_mount();
//  encoder_mount();
//  plug_mount();
//  pico_mount();
//  pico_mount_mount();
//  rotate([0, -90, 0])endstop_mount();
//  motor_spacer();
//  sensor_wheel_magnets(sw_d=60, sw_h=1.5, sw_teeth=3, sw_shaft=6);
//  top_case();
//  bottom_case();
//  lever();
//  rotate([0, 90, 0])anchor_point();
//  pinion();
//  outputGear();
//  transmission(g1=78, g2=12, h1=5, h2=17.5, shaft=shaft_1, mod1=3, mod2=3.45, ring_h=8.5, ring_d1=50, ring_d2=30);

//// Lower transmission ---------------------------------
// transmission(g1=69, g2=32, h1=6, h2=25, shaft=shaft_2, mod1=3.45, mod2=3.85, ring_h=15, ring_d1=60, ring_d2=46);


 transmission(g1=40, g2=16, h1=7, h2=16, shaft=shaft_1, mod1=3.85, mod2=5.05);


// Higher transmission (outdated!!!)------------------------
//  transmission(g1=69,g2=15,h1=6,h2=25,shaft=shaft_2,mod1=3.45,mod2=3.85,ring_h=15,ring_d1=50,ring_d2=30);
//    transmission(g1=57,g2=16,h1=7,h2=15,shaft=shaft_1,mod1=3.85,mod2=5.1);

// High transmission = (78/15)*(69/12)*(57/15)*(50/16) = 355
// Low transmission = (78/15)*(69/12)*(40/32)*(50/16) = 120
}
  
  
module endstop_mount(){
  em_h = 25;
  em_w = 30;
  em_l = 7;
  em_wall = 2;
  
  difference(){
    union(){
      roundedRect([em_l, em_w, em_wall*2], 3, [0,1,0,1]);
      translate([-em_l/2, 0, em_h/2])rotate([0, 90, 0]){
        roundedRect([em_h, em_w, em_wall], 5, [1,0,1,0]);
      }
    }
    translate([1, 10, em_wall]){
      cylinder(d=M3_hole, h=em_wall*2.1, center=true);
    }
    translate([1, -10, em_wall]){
      cylinder(d=M3_hole, h=em_wall*2.1, center=true);
    }
  }
}

module lever(){
  l_l = 150;
  l_wall = 5;
  l_d1 = 25;
  l_d2 = 10;
  l_h = 10;
  
  difference(){
    union(){
      translate([0, 0, l_wall/2]){
        hull(){
          cylinder(d=l_d1, h=l_wall, center=true);
          for(i=[0:1:1])mirror([i,0,0]){
            translate([l_l/2, 0, 0]){
              cylinder(d=l_d2, h=l_wall, center=true);
            }
          }
        }
      }
      translate([0, 0, l_h/2]){
        cylinder(d=l_d1, h=l_h, center=true);
      }
    }
    // Center hole
    translate([0, 0, l_h/2]){
      cylinder(d=8, h=l_h*1.1, center=true);
    }
    translate([0, 0, l_h]){
      cylinder(d=M8_nut_e, h=10, center=true, $fn=6);
    }
    for(i=[0:1:1])mirror([i,0,0]){
      for(j=[0:1:6])
        translate([15+j*10, 0, l_wall/2]){
          cylinder(d=M3_hole, h=l_wall*1.1, center=true);
        }
    }
  }
  
  
}


module h_bridge_mount(){
  hbm_l = 70;
  hbm_w = 50;
  hbm_wall = 2;
  hbm_mount_x = 30;
  hbm_mount_y = 60;
  hb_m_dis = 40;
  
  difference(){
    roundedRect([hbm_w, hbm_l, hbm_wall], 15);
    for(i=[0:1:1])mirror([0,i,0]){
      for(j=[0:1:1])mirror([j,0,0]){
        translate([hb_m_dis/2, hb_m_dis/2, hbm_wall/2]){
          cylinder(d=M3_hole, h=hbm_wall*1.1, center=true);
        }
        translate([hbm_mount_x/2, hbm_mount_y/2, hbm_wall/2]){
          cylinder(d=M3_hole, h=hbm_wall*1.1, center=true);
        }
      }
    }
    
  }
}

module encoder_mount(){
  em_w = 30;
  em_l = 25;
  em_wall = 5;
  em_mount_dis = 20;
  em_mont_e = 5;
  
  difference(){  
    roundedRect([em_w, em_l, em_wall], 5);
    translate([em_mount_dis/2, 5-em_l/2, em_wall/2]){
      cylinder(d=M3_hole, h=em_wall*1.1, center=true);
    }
    translate([-em_mount_dis/2, 5-em_l/2, em_wall/2]){
      cylinder(d=M3_hole, h=em_wall*1.1, center=true);
    }

    translate([0, em_l/2, em_wall/2]){
      cylinder(d=10, h=em_wall*1.1, center=true);
    }
  }
}

module plug_mount(){
    
  pm_l = 80;
  pm_w = 67;
  pm_h = 5;
  pm_wall = 2;
  pm_m_edge_x = 4;
  pm_m_edge_y = 12;
  
  grid_no_x = 2;
  grid_no_y = 4;
  
  difference(){
    roundedRect([pm_l, pm_w, pm_h], 5);
    translate([-10, 0, pm_wall]){
      roundedRect([pm_l, pm_w-14, pm_h*1.1], 5);
    }
    translate([-30, 7, -0.1]){
      roundedRect([pm_l, pm_w, pm_h*1.1], 5);
    }

    // Mount holes on Servo
    for(i=[0:1:1])mirror([0,i,0]){
      for(j=[0:1:1])mirror([j,0,0]){
        translate([pm_l/2-pm_m_edge_y, pm_w/2-pm_m_edge_x, pm_h/2]){
          cylinder(d=M3_hole, h=pm_h*1.1, center=true);
        }
      }
    }
    
    for(x=[0:1:grid_no_x]){
      for(y=[0:1:grid_no_y]){
        translate([pm_l/2-x*10 - 5, 13.5+y*10-pm_w/2, pm_h/2]){
          cylinder(d=M3_hole, h=pm_h*1.1, center=true);
        }
      }
    }
    
    
    
  }
}

module pico_mount(){
  oled_m_d1 = 21;
  oled_m_d2 = 21.5;
  oled_x = -5;
  oled_y = 14;
  oled_gap_w = 12;
  oled_gap_h = 5;
  oled_gap_x = 0;
  oled_gap_y = 11.5;
  
  pico_m_d1 = 47.26;
  pico_m_d2 = 11.4;
  pico_x = 0;
  pico_y = -13;
  pico_gap_w = 52;
  pico_gap_h = 3;
  pico_gap_x = 0;
  pico_gap_y = 17.78/2;
  
  grid_no_x = 11;
  grid_no_y = 4;
  grid_dis = 5;
  grid_x = -27.5;
  grid_y = 3;
  
  pm_l = 80;
  pm_w = 67;
  pm_wall = 2;
  pm_m_edge_x = 4;
  pm_m_edge_y = 12;
  
  difference(){
    roundedRect([pm_l, pm_w, pm_wall], 5);
    // OLED mount holes
    translate([oled_x, oled_y, pm_wall/2]){
      for(i=[0:1:1])mirror([0,i,0]){
        for(j=[0:1:1])mirror([j,0,0]){
          translate([oled_m_d1/2, oled_m_d2/2, 0]){
            cylinder(d=1.5, h=pm_wall*1.1, center=true);
          }
        }
      }
      translate([oled_gap_x, oled_gap_y, 0]){
        cube(size=[oled_gap_w, oled_gap_h, pm_wall*1.1], center=true);
      }
    }

    // PICO mount holes
    translate([pico_x, pico_y, pm_wall/2]){
      for(i=[0:1:1])mirror([0,i,0]){
        for(j=[0:1:1])mirror([j,0,0]){
          translate([pico_m_d1/2, pico_m_d2/2, 0]){
            cylinder(d=1.5, h=pm_wall*1.1, center=true);
          }
        }
      }
      for(i=[0:1:1])mirror([0,i,0])
      translate([pico_gap_x, pico_gap_y, 0]){
        cube(size=[pico_gap_w, pico_gap_h, pm_wall*1.1], center=true);
      }
      translate([38.5, 0, -pm_wall/2-0.1]){
        roundedRect([25, 13, pm_wall*1.1], 3);
      }
    }
    // Mount holes on Servo
    for(i=[0:1:1])mirror([0,i,0]){
      for(j=[0:1:1])mirror([j,0,0]){
        translate([pm_l/2-pm_m_edge_y, pm_w/2-pm_m_edge_x, pm_wall/2]){
          cylinder(d=M3_hole, h=pm_wall*1.1, center=true);
        }
      }
    }
    
    // Mount holes grid
    for(x=[0:1:grid_no_x]){
      for(y=[0:1:grid_no_y]){
        translate([grid_x+x*grid_dis, grid_y+y*grid_dis, pm_wall/2]){
          if(x<2 || x>7){
            cylinder(d=M3_hole, h=pm_wall*1.1, center=true);
          }
        }
      }
    }
    
    
    
  }
}

module pico_mount_mount(){
  pmm_l = 80;
  pmm_w = 7;
  pmm_wall = 10;
  
  pmm_m_dis = 70.5;
  pmm_m_dis_2 = 56;
  
  difference(){
    roundedRect([pmm_l, pmm_w, pmm_wall], 2);
    for(i=[0:1:1])mirror([i,0,0]){
      translate([pmm_m_dis/2, 0, pmm_wall-2]){
        rotate([90, 0, 0])
        hull(){
          cylinder(d=5.5, h=pmm_w*1.1, center=true);
          translate([0,10,0]){
            cylinder(d=5.5, h=pmm_w*1.1, center=true);
          }
        }
      }
      translate([pmm_m_dis_2/2, 0, pmm_wall/2]){
        cylinder(d=M3_hole, h=pmm_wall*1.1, center=true);
      }
    }
  }
  
}

module pinion(){
  difference(){
    union(){
      gear(15, 15, 6, 3);
      translate([0, 0, 4]){
          cylinder(d=23, h=8, center=true);
      }
    }
    
    for(i=[0:90:270])
    rotate([0, 0, i+45])
    translate([11.5, 0, 4]){
      cylinder(d=3, h=9, center=true);
    }
      
    
    translate([0, 0, 4]){
      cylinder(d=6, h=9, center=true);
      translate([7, 0, 0])rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=60, center=true);
        hull(){
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          translate([10, 0, 0])
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
        }
      }
    }
  }

}
  
module outputGear(){
  translate([shaft_x2, 0, 32])rotate([0, 0, -0]){
    difference(){
      transmission(g1=50,
                   g2=0,
                   h1=12,
                   h2=0,
                   shaft=shaft_3,
                   mod1=5,
                   mod2=0);
      for(i=[0:30:360])rotate([0, 0, i])
      translate([30, 0, 0]){
        cylinder(d=5, h=50, center=true);
        translate([0, 0, 12]){
          cylinder(d=10, h=12, center=true);
        }
      }
    }
  }
}


module anchor_point(){
  ap_h = 29;
  ap_d = 67;
  ap_shift = 12;
  
  translate([0, 0, ap_h/2]){
    difference(){
      union(){
        hull(){
          translate([0, 0, -1])
          cylinder(d=ap_d, h=ap_h-2, center=true);
          cylinder(d=shaft_2+2*s_wall, h=ap_h, center=true);
        }
        translate([0, 0, (s_wall-ap_h)/2])
        cylinder(d=ap_d+20, h=s_wall, center=true);
      }
      translate([0, 0, ap_h/2])
      cylinder(d=shaft_2, 14, center=true);
      for(j=[0:1:1])mirror([0,j,0])
      for(i=[0:1:1])mirror([i,0,0]){
        rotate([0, 0, 100])
        translate([-ap_m_r, 0, (s_wall-ap_h)/2])
        cylinder(d=M3_hole, h=s_wall*1.1, center=true);
      }
      
      translate([0, 0, -8])
      hull(){
        translate([0, 0, -5])
        cylinder(d=ap_d-2*s_wall, h=ap_h, center=true);
        cylinder(d=ap_d-20, h=ap_h, center=true);
      }
      for(i=[0:1:1])mirror([i,0,0]){
        translate([ap_d/2+ap_shift, 0, 0])
        cube(size=[ap_d, ap_d*2.1, ap_h*1.1], center=true);
      }
    }
  }
  
}

module motor_spacer(){
  ms_d = 45;
  ms_h = 3;
  
  difference(){
    cylinder(d=ms_d, h=ms_h, center=true);
    cylinder(d=23, h=ms_h*1.1, center=true);
    // Motor mount holes
    for(i=[0:90:360])
    rotate([0, 0, i])
    translate([motor_m_dis/2, 0, 0])
    cylinder(d=5.5, h=ms_h*1.1, center=true);

  }
}

module top_case(){
  tc_h = 65;
  tc_wall = 2;
  
  mount_w = 90;
  mount_l = s_l + 50;
  mount_h = 5;
  mount_hole_e_x = 12;
  mount_hole_e_y = 17;
  mount_hole_d = 15;
  
  difference(){
    union(){
      roundedRect([s_l,s_w,tc_h],5);
      roundedRect([mount_l,mount_w,mount_h],5);
      hull(){
        translate([0, 0, mount_h/2]){
          cube(size=[mount_l, tc_wall*2, mount_h], center=true);
        }
        translate([0, 0, 30]){
          cube(size=[s_l, tc_wall*2, 0.1], center=true);
        }
      }
      for(i=[0:1:1])mirror([0,i,0])
      translate([0, mount_w/2-tc_wall, 0])
      hull(){
        translate([0, 0, mount_h/2]){
          cube(size=[mount_l-10, tc_wall*2, mount_h], center=true);
        }
        translate([0, 0, 30]){
          cube(size=[s_l, tc_wall*2, 0.1], center=true);
        }
      }
    }
    difference(){
      translate([0, 0, -0.1]){
        roundedRect([s_l-2*tc_wall,s_w-2*tc_wall,tc_h+0.2],5);
      }

      translate([0, 0, tc_h/2])
      for(i=[0:1:1])mirror([0,i,0]){
        translate([shaft_x1-motor_shift_x+30, s_w/2-mount_e, 0]){
          hull(){
            translate([-3, 0, 0]){
              cube(size=[1,4,tc_h], center=true);
            }
            cube(size=[10,0.1,tc_h], center=true);
            translate([0,10,0])
            cylinder(d=10, h=tc_h*1.1, center=true);
          }
        }
        translate([shaft_x1-motor_shift_x-30, s_w/2-mount_e, 0]){
          hull(){
            translate([3, 0, 0]){
              cube(size=[1,4,tc_h], center=true);
            }
            cube(size=[10,0.1,tc_h], center=true);
            translate([0,10,0])
            cylinder(d=10, h=tc_h*1.1, center=true);
          }
        }

        translate([s_l/2-mount_e, s_w/2-mount_e, 0]){
          hull(){
            cylinder(d=10, h=tc_h*1.1, center=true);
            translate([10,10,0])
            cylinder(d=10, h=tc_h*1.1, center=true);
          }
            
        }
        translate([-(s_l/2-mount_e), s_w/2-mount_e, 0]){
          hull(){
            cylinder(d=10, h=tc_h*1.1, center=true);
            translate([-10,10,0])
            cylinder(d=10, h=tc_h*1.1, center=true);
          }            
        }
      }



    }

    // Holes Servo mounts
    for(j=[0:1:1])mirror([j,0,0])
    for(i=[0:1:1])mirror([0,i,0]){
      translate([mount_l/2 - mount_hole_e_x,
                 mount_w/2 - mount_hole_e_y,
                 mount_h/2])
      cylinder(d=mount_hole_d, h=mount_h*1.1, center=true);
    }

    // Mount holes top and bottom plate
    translate([0, 0, tc_h/2]){
      for(i=[0:1:1])mirror([0,i,0]){
        translate([shaft_x1-motor_shift_x+30, s_w/2-mount_e, 0]){
          cylinder(d=5.5, h=tc_h*1.1, center=true);
        }
        translate([shaft_x1-motor_shift_x-30, s_w/2-mount_e, 0]){
          cylinder(d=5.5, h=tc_h*1.1, center=true);
        }

        translate([s_l/2-mount_e, s_w/2-mount_e, 0]){
          cylinder(d=5.5, h=tc_h*1.1, center=true);
        }
        translate([-(s_l/2-mount_e), s_w/2-mount_e, 0]){
          cylinder(d=5.5, h=tc_h*1.1, center=true);
        }
      }
    }
    
    // bottom cut for anchor mount
    translate([0, 0, 2.4]){
      for(i=[0:1:1])mirror([0,i,0]){
        translate([shaft_x1-motor_shift_x-30-8, s_w/2-mount_e, 0]){
          hull(){
            cube(size=[10, 15, 5], center=true);
            translate([0, 0, 10]){
              cube(size=[0.1, 15, 0.1], center=true);
            }
          }
        }

      }
    }

  }
}

module bottom_case(){
  bc_h = 97;
  bc_wall = 2;
  
  mount_w = 90;
  mount_l = s_l + 50;
  mount_h = 5;
  mount_hole_e_x = 12;
  mount_hole_e_y = 12;
  mount_hole_d = 15;
  
  difference(){
    union(){
      roundedRect([s_l,s_w,bc_h],5);
      translate([57, 30-s_w/2, 60])rotate([90, 0, 0]){
        hull(){
          translate([0, -35, 17]){
            cube(size=[82,0.2,40], center=true);
          }
          translate([0, -10, 0]){
            roundedRect([82,74+20,30], 3, [1,1,0,0]);
          }
        }
      }




    }
    difference(){
      translate([0, 0, bc_wall]){
        roundedRect([s_l-2*bc_wall,s_w-2*bc_wall,bc_h+0.2],5);
      }

      translate([0, 0, bc_h/2-5])
      for(i=[0:1:1])mirror([0,i,0]){
        translate([shaft_x1-motor_shift_x+30, s_w/2-mount_e, 0]){
          hull(){
            cylinder(d=10, h=bc_h, center=true);
            translate([0,10,0])
            cylinder(d=10, h=bc_h, center=true);
          }
        }
        translate([shaft_x1-motor_shift_x-30, s_w/2-mount_e, 0]){
          hull(){
            cylinder(d=10, h=bc_h, center=true);
            translate([0,10,0])
            cylinder(d=10, h=bc_h, center=true);
          }
        }

        translate([s_l/2-mount_e, s_w/2-mount_e, 0]){
          hull(){
            cylinder(d=10, h=bc_h, center=true);
            translate([10,10,0])
            cylinder(d=10, h=bc_h, center=true);
          }
            
        }
        translate([-(s_l/2-mount_e), s_w/2-mount_e, 0]){
          hull(){
            cylinder(d=10, h=bc_h, center=true);
            translate([-10,10,0])
            cylinder(d=10, h=bc_h, center=true);
          }            
        }
      }

    }


    // Pico cut
    translate([57, 30-s_w/2, 70])rotate([90, 0, 0]){
      roundedRect([62,72,50], 3);
      translate([0, 5, 0])
      for(j=[0:1:1])mirror([0,j,0])
      for(i=[0:1:1])mirror([i,0,0]){
        translate([-37, 15, 0]){
          cylinder(d=M3_hole, h=100, center=true);
        }
        translate([20, 45, 0]){
          cylinder(d=M3_hole, h=100, center=true);
        }
      }
    }
    translate([57, 27-s_w/2, 20])rotate([0, 0, 0]){
      roundedRect([87,50,78], 3);
    }
    
    // USB cable cut
    translate([97.6-40, 3-s_w/2, 44])rotate([0, 90, 0]){
      hull(){
        roundedRect([15,10,50], 5);
//          translate([-5, 0, -12]){
//            roundedRect([25,10,1], 5);
//          }
      }
    }

    // Plugs cable cut
    translate([57, 45-s_w/2, 55])rotate([0, 90, 0]){
      roundedRect([35,10,50], 3);
    }

    // Mount holes top and bottom plate
    translate([0, 0, bc_h/2]){
      for(i=[0:1:1])mirror([0,i,0]){
        translate([shaft_x1-motor_shift_x+30, s_w/2-mount_e, 0]){
          cylinder(d=6.0, h=bc_h*1.1, center=true);
        }
        translate([shaft_x1-motor_shift_x-30, s_w/2-mount_e, 0]){
          cylinder(d=6.0, h=bc_h*1.1, center=true);
        }

        translate([s_l/2-mount_e, s_w/2-mount_e, 0]){
          cylinder(d=6.0, h=bc_h*1.1, center=true);
        }
        translate([-(s_l/2-mount_e), s_w/2-mount_e, 0]){
          cylinder(d=6.0, h=bc_h*1.1, center=true);
        }
      }
    }
    

  }
}



module base_plate(m_h0=6,m_h1=15.5, m_h2=28, type=0){
  difference(){
    roundedRect([s_l,s_w,s_wall],5);
    if(type==0){
      translate([-motor_shift_x, 0, s_wall/2]){
        // Motor shaft hole
        cylinder(d=23, h=s_wall*1.1, center=true);

        // cable cut sensor wheel
        translate([-25, -30, 0]){
          cylinder(d=8, h=s_wall*1.1, center=true);
        }

        // cable cut end switch
        translate([130, -30, 0]){
          cylinder(d=8, h=s_wall*1.1, center=true);
        }
        
        // Motor mount holes
        for(i=[0:90:360])
        rotate([0, 0, i])
        translate([motor_m_dis/2, 0, 0])
        cylinder(d=5.5, h=s_wall*1.1, center=true);
        
        // Sensors mount holes
        for(j=[0:1:1])mirror([0,j,0]){
          translate([motor_shift_x-s_l/2+mount_e, 10, 0])
          cylinder(d=M3_hole, h=s_wall*1.1, center=true);

          // H bridge mount holes
          translate([motor_shift_x+15, 30, 0])
          cylinder(d=M3_hole, h=s_wall*1.1, center=true);
          translate([motor_shift_x-15, 30, 0])
          cylinder(d=M3_hole, h=s_wall*1.1, center=true);


          translate([motor_shift_x+s_l/2-mount_e, 10, 0])
          cylinder(d=M3_hole, h=s_wall*1.1, center=true);
          translate([motor_shift_x+s_l/2-mount_e-20, 10, 0])
          cylinder(d=M3_hole, h=s_wall*1.1, center=true);

        }
        
        // Anchor point mount holes
        for(j=[0:1:1])mirror([0,j,0])
        for(i=[0:1:1])mirror([i,0,0]){
          rotate([0, 0, 100])
          translate([-ap_m_r, 0, 0])
          cylinder(d=M3_hole, h=s_wall*1.1, center=true);
        }
      }
    }
    
    // Output shaft hole
    translate([shaft_x2-motor_shift_x, 0, s_wall/2]){
      cylinder(d=shaft_3, h=s_wall*2.1, center=true);
    }
    
    // Mount holes base plates
    for(i=[0:1:1])mirror([0,i,0]){
      translate([shaft_x1-motor_shift_x+30, s_w/2-mount_e, s_wall/2]){
        cylinder(d=5, h=s_wall*1.1, center=true);
      }
      translate([shaft_x1-motor_shift_x-30, s_w/2-mount_e, s_wall/2]){
        cylinder(d=5, h=s_wall*1.1, center=true);
      }

      translate([s_l/2-mount_e, s_w/2-mount_e, s_wall/2]){
        cylinder(d=5, h=s_wall*1.1, center=true);
      }
      translate([-(s_l/2-mount_e), s_w/2-mount_e, s_wall/2]){
        cylinder(d=5, h=s_wall*1.1, center=true);
      }
    }
  }

  // shaft 2 mount point (above motor)
  if(type==1){
    translate([-motor_shift_x, 0, m_h0/2]){
      difference(){
        cylinder(d1=40, d2=20, h=m_h0, center=true);
        cylinder(d=shaft_2, h=m_h0*1.1, center=true);
      }
    }
  }
  
  // Shaft 1 mount point (center shaft)
  translate([shaft_x1-motor_shift_x, 0, m_h1/2]){
    difference(){
      cylinder(d1=40, d2=20, h=m_h1, center=true);
      cylinder(d=shaft_1, h=m_h1*1.1, center=true);
    }
  }

  // Output shaft mount
  translate([shaft_x2-motor_shift_x, 0, m_h2/2]){
    difference(){
      cylinder(d=35, h=m_h2, center=true);
      cylinder(d=shaft_3, h=m_h2*1.1, center=true);
      translate([0, 0, (m_h2-bb8_h)/2+0.1]){
        cylinder(d=bb8_do, h=bb8_h, center=true);
        cylinder(d=bb8_do - 5, h=bb8_h+4, center=true);
      }
    }
  }
}

module transmission(g1=50,
                    g2=15,
                    h1=5,
                    h2=10,
                    shaft=M3_hole,
                    mod1=3,
                    mod2=3,
                    ring_h = 0,
                    ring_d1 = 20,
                    ring_d2 = 10){
    translate([0, 0, 1])mirror([0,0,1])
    gear(g1, 1, shaft, mod1, 0.98);
    translate([0, 0, 1])
    gear(g1, h1-1, shaft,mod1);
    if(ring_h > 0){
      translate([0, 0, h1+ring_h/2])
      difference(){
        cylinder(d1=ring_d1, d2=ring_d2, h=ring_h, center=true);
        cylinder(d=shaft, h=ring_h*1.1, center=true);
      }
    }
                      
    if(h2 > 0){
      translate([0, 0, h1])
      gear(g2, h2, shaft, mod2);
    }
}

module sensor_wheel_magnets(sw_d=50, sw_h=1.5, sw_teeth=6, sw_shaft=3){
  
  translate([0, 0, sw_h/2]){
    difference(){
      union(){
        cylinder(d=sw_d, h=sw_h, center=true);
        translate([0, 0, 2-sw_h/2])
        cylinder(d=27, h=4, center=true);
      }

      for(i=[0:1:sw_teeth-1])rotate([0, 0, i*360/sw_teeth])
      translate([sw_d/2-7, 0, 0])
      cube(size=[5, 20, sw_h*1.1], center=true);

      cylinder(d=20, h=26.1, center=true);
      translate([0, 50, 5.80])      
      cube(size=[10,100,10], center=true);
      translate([0, 0, 4.55])
      difference(){
        cylinder(d=23.5, h=10, center=true);
        for(i=[0:90:270])
        rotate([0, 0, i+45])
        translate([11.75, 0, 0]){
          cylinder(d=3, h=10, center=true);
        }
      }
    }
  }
  
}

module sensor_wheel_light(sw_d=50, sw_h=1.5, sw_teeth=6, sw_shaft=3){
  
  translate([0, 0, sw_h/2]){
    difference(){
      union(){
        cylinder(d=sw_d, h=sw_h, center=true);
        translate([0, 0, 2-sw_h/2])
        cylinder(d=27, h=4, center=true);
      }
      difference(){
        union(){
          for(i=[0:1:sw_teeth-1])rotate([0, 0, i*360/sw_teeth])
          hull(){
            translate([sw_d/2, 0, 0])
            cube(size=[sw_d, 0.1, sw_h*1.1], center=true);
            rotate([0, 0, 180/sw_teeth])translate([sw_d/2, 0, 0])
            cube(size=[sw_d, 0.1, sw_h*1.1], center=true);
          }
        }
        cylinder(d=sw_d-14, h=sw_h*1.2, center=true);
        difference(){
          cylinder(d=sw_d, h=sw_h*1.2, center=true);
          cylinder(d=sw_d-3, h=sw_h*1.2, center=true);
        }
      }
      cylinder(d=20, h=26.1, center=true);
      translate([0, 50, 5.80])      
      cube(size=[10,100,10], center=true);
      translate([0, 0, 4.55])
      difference(){
        cylinder(d=23.5, h=10, center=true);
        for(i=[0:90:270])
        rotate([0, 0, i+45])
        translate([11.75, 0, 0]){
          cylinder(d=3, h=10, center=true);
        }
      }
    }
  }
  
}


module gear(teeth=10,h=5, shaft=M3_hole, mod=3, s=1.0){
  alpha = 180/teeth;
  r=(mod/2.0)/tan(alpha);
  
  x = cos(alpha) * r;
  t_r = mod/sqrt(3);
  t_h = mod*sqrt(3)/2.0;
  
  difference(){
    linear_extrude(height = h, scale=s){
      union(){
        for(i=[0:1:teeth-1]){
          rotate([0, 0, i*360/teeth]){  
            translate([x+(t_h-t_r),0,0]){
              circle(r=t_r, $fn=3);
            }
          }
        }
        rotate([0, 0, alpha])
        circle(r=r, $fn=teeth);
      }
    }
    translate([0, 0, h/2]){
      cylinder(d=shaft, h=h*1.1, center=true);
    }
  }
  
}


module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}